package com.ruoyi.bst.area.service;

import java.math.BigDecimal;
import java.util.List;

import com.ruoyi.bst.area.domain.Area;
import com.ruoyi.bst.area.domain.AreaQuery;
import com.ruoyi.bst.area.domain.AreaVO;
import com.ruoyi.bst.area.domain.vo.LocationAreaVO;

/**
 * 运营区Service接口
 *
 * @author ruoyi
 * @date 2025-03-14
 */
public interface AreaService
{
    /**
     * 查询运营区
     *
     * @param id 运营区主键
     * @return 运营区
     */
    public AreaVO selectAreaById(Long id, boolean scope);

    default AreaVO selectAreaById(Long id) {
        return this.selectAreaById(id, false);
    }

    /**
     * 查询运营区列表
     *
     * @param area 运营区
     * @return 运营区集合
     */
    public List<AreaVO> selectAreaList(AreaQuery area);

    /**
     * 新增运营区
     *
     * @param area 运营区
     * @return 结果
     */
    public int insertArea(Area area);

    /**
     * 修改运营区
     *
     * @param area 运营区
     * @return 结果
     */
    public int updateArea(Area area);

    /**
     * 批量删除运营区
     *
     * @param ids 需要删除的运营区主键集合
     * @return 结果
     */
    public int deleteAreaByIds(Long[] ids);

    /**
     * 删除运营区信息
     *
     * @param id 运营区主键
     * @return 结果
     */
    public int deleteAreaById(Long id);

    /**
     * 逻辑删除运营区
     *
     * @param ids 需要删除的运营区主键集合
     * @return 结果
     */
    public int logicDel(List<Long> ids);

    public AreaVO selectOne(AreaQuery query);

    public Long selectAreaByStoreId(Long storeId);

    /**
     * 查询运营区简单数据
     */
    public List<AreaVO> selectSimpleList(AreaQuery query);

    /**
     * 查询定位所属区域信息
     * @param lon 经度
     * @param lat 纬度
     * @param areaId 运营区ID
     * @return 定位所属区域信息
     */
    public LocationAreaVO selectLocationArea(BigDecimal lon, BigDecimal lat, Long areaId);

    /**
     * 查询运营区ID列表
     * @param areaQuery 运营区查询条件
     * @return 运营区ID列表
     */
    public List<Long> selectIdList(AreaQuery query);

    /**
     * 查询附近的运营区
     * @param query
     */
    public AreaVO selectNearBy(AreaQuery query);

}
